using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Threading;

namespace BackgroundWorkerExample
{
    // Example C-7. Using a BackgroundWorker

    partial class MyWindow : Window
    {

        BackgroundWorker bw;

        public MyWindow()
        {
            bw = new BackgroundWorker();
            bw.DoWork += new DoWorkEventHandler(bw_DoWork);
            bw.ProgressChanged += bw_ProgressChanged;
            bw.RunWorkerCompleted += bw_RunWorkerCompleted;
            bw.WorkerReportsProgress = true;
            bw.RunWorkerAsync();
        }

        void bw_DoWork(object sender, DoWorkEventArgs e)
        {

            // Running on a worker thread
            for (int i = 0; i < 10; ++i)
            {
                int percent = i * 10;
                bw.ReportProgress(percent);
                Thread.Sleep(1000);
            }

            // The BackgroundWorker will raise the RunWorkerCompleted
            // event when this method returns.
        }

        void bw_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            // Running on a UI thread
            this.Title = "Working: " + e.ProgressPercentage + "%";
        }

        void bw_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            // Running on a UI thread
            this.Title = "Finished";
        }

    }

    // End of Example C-7.
}